#include <def21367.h>
#define N 128

.section/DATA64 seg_dmda;
.var input[N]="inwave1.hex";
.var input2[N]="inwave2.hex";
.var output[N];
.var output2[N];
.var delayline[5];
.var delayline2[5];

.section/DATA64 seg_pmda;
.var biquad[5]= "coeffs1.dat";
.var biquad2[5]= "coeffs2.dat";
.var expected[N]="expected_output1.dat";
.var expected2[N]="expected_output2.dat";

.section/pm seg_pmco;
.global _main;
_main:
//Enable Circular Buffers and SIMD
bit set mode1 CBUFEN|PEYEN;
i0=delayline;   //Delayline Pointer
i8=delayline2;   //Delayline Pointer
i2=input2;       //Input Pointer
b3=output2;      //Output Pointer
l3=N;           //Set output wrap length
i4=input;       //Input Pointer
b5=output;      //Output Pointer
l5=N;           //Set output wrap length
b1=biquad;      //Biquad Coeffs pointer
l1=5;           //Set biquad wrap length
b9=biquad2;      //Biquad Coeffs pointer
l9=5;           //Set biquad wrap length

//Modifiers
m5=0;
m6=1;
m7=-1;
m13=0;
m14=1;
m15=-1;
m4=-3;
m12=-3;

//Clear the multipliers
r6=0;
r7=0;
mrf=r6*r7(uuf);
mrb=r6*r7(uuf), s2=dm(i2,m6);

//Read first input, B0
r2=dm(i4,m6), r4=pm(i9,m14);
r4=dm(i1,m6);

//Read X-1, B1
mrf=r2*r4(uuf),r0=dm(i0,m6),r4=pm(i9,m14);
r4=dm(i1,m6),r0=pm(i8,m14);

//Adjust output pointer
r12=r12-r12,r12=dm(i5,m7);
r12=dm(i3,m7);

//Read  Y-1
r13=r13-r13,r12=dm(m6,i0);
s12=pm(m14,i8);
nop;nop;nop;nop;nop;nop;

lcntr=N, do iir64_end until lce;

iir64_start:
    //Multiply lower halves in MRF
    //Read X-2, B2
    mrf=mrf + r0*r4 (uuf), r0=dm(i0,m6), r4=pm(i9,m14);
    r4=dm(i1,m6), r0=pm(i8,m14);
    //Read A1, Adjust DL pointer
    mrf=mrf + r0*r4 (uuf), r0=dm(i0,m6), r4=pm(i9,m14);
    r4=dm(i1,m6), r0=pm(i8,m14);
    //Read Y-1, A2
    mrf=mrf - r12*r4 (uuf), r0=dm(i0,m7), r4=pm(i9,m14);
    r4=dm(i1,m6), r0=pm(i8,m15);
    //Read Y-2, B0
    mrf=mrf - r0*r4 (uuf), r0=dm(i0,m7), r4=pm(i9,m14);

    //Copy from most significant 32-bits of the low half multiplication
    r7=r7-r7,r4=dm(i1,m6), r0=pm(i8,m15);
    r6=mr1f;
    mr1b=r7;
    mr0b=r6;

    //Cross multiply upper and lower halves in MRB
    //Multiply upper halves in MRF
    //Read Y-1
    mrf=r3*r5 (ssf),r0=dm(i0,m7);
    mrb=mrb+r3*r4 (suf),s0=pm(i8,m15);
    //Read X-1, B1
    mrb=mrb+r5*r2 (suf),r0=dm(i0,m5),r4=pm(i9,m14);
    r4=dm(i1,m6),r0=pm(i8,m13);
    //Update X-1
    mrf=mrf+r1*r5 (ssf); 
    mrb=mrb+r1*r4 (suf), dm(i0,m6)=r2;
    pm(i8,m14)=s2;
    //Read X-2, B2
    mrb=mrb+r5*r0 (suf), r2=dm(i0,m5),r4=pm(i9,m14);
    r4=dm(i1,m6),r2=pm(i8,m13);
    //Update X-2
    mrf=mrf+r3*r5 (ssf), dm(i0,m6)=r0;
    mrb=mrb+r3*r4 (suf), pm(i8,m14)=s0;
    //Read Y-1, A1
    mrb=mrb+r5*r2 (suf),r0=dm(i0,m6),r4=pm(i9,m14);
    r4=dm(i1,m6), r0=pm(i8,m14);
    mrf=mrf-r1*r5 (ssf);
    //Read Y-2
    mrb=mrb-r1*r4 (suf), r2=dm(i0,m5);
    s2=pm(i8,m13);
    //Update Y-2, read A2
    mrb=mrb-r5*r0 (suf), dm(i0,m4)=r0, r4=pm(i9,m14);
    r4=dm(i1,m6), pm(i8,m12)=r0;
    mrf=mrf-r3*r5 (ssf);

    //Read X-1
    mrb=mrb-r3*r4 (suf), r0=dm(i0,m6);
    mrb=mrb-r5*r2 (suf), s0=pm(i8,m14);

    //Collect MRB and MRF into registers for final addition
    //Store output
    r6=mr0b, dm(i5,m6)=r12;
    r7=mr1b, dm(i3,m6)=s12;
    //Read next input
    r12=mr0f,r2=dm(i4,m6);
    r13=mr1f,s2=dm(i2,m6);


    //Shift result of mixed multiplies by 31 bits
    //Modify DL Pointer
    r6=lshift r6 by -31,r4=pm(i8,m14);
    r6=r6 OR lshift r7 by 1,r4=dm(i0,m6);
    r7=lshift r7 by -31;

    //Final 64-bit addition of MRB and MRF
    //Read B0
    r12=r12+r6, r4=dm(i1,m6);
    r13=r13+r7+CI,s4=pm(i9,m14);

    //Update Y-1, read B1
    mrf=r2*r4 (uuf), dm(i0,m7)=r12, r4=pm(i9,m14);
iir64_end: r4=dm(i1,m6),pm(i8,m15)=r12;

//Save final output
dm(i5,m6)=r12;
dm(i3,m6)=s12;

_main.end: jump(pc,0);
